package org.lucci.madhoc.broadcast;

import java.awt.Color;

import org.lucci.madhoc.messaging.TransferableObject;
import org.lucci.madhoc.network.Station;

/*
 * Created on May 17, 2005
 */

/**
 * @author luc.hogie
 */
public class Ad extends TransferableObject
{
	private int id;
	private Color color;
	public static final int SEARCH = 0;
	public static final int SELL = 1;

	private int type = SELL;
	private String brand;
	private String model;
	private boolean matched = false;
	private Station creatorStation;
	private double expirationDate;
	

	public String getBrand()
	{
		return brand;
	}

	public String getModel()
	{
		return model;
	}

	public int getType()
	{
		return type;
	}

	public void setBrand(String string)
	{
		brand = string;
	}


	public void setModel(String string)
	{
		model = string;
	}

	public void setType(int i)
	{
		type = i;
	}

	public Color getColor()
	{
		if ( color == null )
		{
			int r = getId() % 255;
			int g = (int) (Math.sqrt(getId()) % 255);
			int b = getId() / 3 % 255;
			color = new Color(r, g, b);
		}

		return color;
	}
	

	public boolean match(Ad ad)
	{
		return getBrand().equals(ad.getBrand()) && getModel().equals(ad.getModel()) && getType() != ad.getType();
	}

	public boolean isMatched()
	{
		return matched;
	}

	public void setMatched(boolean b)
	{
		matched = b;
	}


	public Object clone()
	{
		Ad ad = (Ad) super.clone();
		ad.id = getId();
		ad.brand = getBrand();
		ad.model = getModel();
		ad.matched = isMatched();
		ad.type = getType();
		ad.expirationDate = getExpirationDate();
		ad.color = getColor();
		return ad;
	}

	public int getSizeInBytes()
	{
		return 500; 
	}

	public Station getCreatorStation()
	{
		return creatorStation;
	}

	public void setCreatorStation(Station station)
	{
		creatorStation = station;
	}

	public int getId()
	{
		return id;
	}
	public double getExpirationDate()
	{
		return expirationDate;
	}

	public void setExpirationDate(double l)
	{
		expirationDate = l;
	}

	public int hashCode()
	{
		return getId();
	}

	public boolean equals(Object o)
	{
		return o instanceof Ad && o.hashCode() == hashCode();
	}

	public String toString()
	{
		return String.valueOf(getId());	
	}
	/**
	 * @param color The color to set.
	 */
	public void setColor(Color color)
	{
		this.color = color;
	}
	public void setId(int id)
	{
		if (this.id != 0)
				throw new IllegalStateException("id already defined");

		this.id = id;
	}
}
