package org.lucci.madhoc.broadcast;

import org.lucci.madhoc.messaging.MessageInformation;

public class BroadcastInformation extends MessageInformation
{
	private Class targetApplicationClass;
	private int hops = 0; 
	private int maxHop = 2;
	private boolean shouldBeForwardedToNewNeighbors;

	/* (non-Javadoc)
	 * @see org.lucci.madhoc.messaging.TranferableObject#getSizeInBytes()
	 */
	public int getSizeInBytes()
	{
		return 17;
	}

	public Object clone()
	{
		BroadcastInformation clone = (BroadcastInformation) super.clone();
		clone.targetApplicationClass = this.targetApplicationClass;
		clone.setMaxHop(getMaxHop());
		clone.hops = getHops();
		clone.setShouldBeForwardedToNewNeighbors(isShouldBeForwardedToNewNeighbors());
		return clone;
	}

	public Class getTargetApplicationClass()
	{
		return targetApplicationClass;
	}

	public void setTargetApplicationClass(Class targetApplicationClass)
	{
		this.targetApplicationClass = targetApplicationClass;
	}
	
	public int getMaxHop()
	{
		return maxHop;
	}
	public void setMaxHop(int maxHop)
	{
		if (maxHop < 0)
			throw new IllegalArgumentException();
	
		this.maxHop = maxHop;
	}
	public int getHops()
	{
		return hops;
	}
	public void addHops()
	{
		++this.hops;
	}

	public boolean isShouldBeForwardedToNewNeighbors()
	{
		return shouldBeForwardedToNewNeighbors;
	}
	public void setShouldBeForwardedToNewNeighbors(boolean shouldBeForwardedToNewNeighbors)
	{
		this.shouldBeForwardedToNewNeighbors = shouldBeForwardedToNewNeighbors;
	}
}
