package org.lucci.madhoc.broadcast;

import org.lucci.madhoc.simulation.Monitor;
import org.lucci.madhoc.simulation.TerminationCondition;

/*
 * Created on Apr 26, 2005
 */

/**
 * @author luc.hogie
 */
public class MinimumCoverageTerminationCondition extends TerminationCondition
{
	private double acceptableCoverage = 1;

	/* (non-Javadoc)
	 * @see org.lucci.madhoc.simulation.SimulationTerminationCondition#simulationHasCompleted(org.lucci.madhoc.simulation.Simulation)
	 */
	public boolean applicationHasCompleted(Monitor app)
	{
		BroadcastingMonitor broadcastingApp = (BroadcastingMonitor) app;
		return broadcastingApp.getAverageCoverageRate(app.getNetwork().getStations()) >= getAcceptableCoverage();
	}

	/* (non-Javadoc)
	 * @see org.lucci.madhoc.config.Configurable#configure()
	 */
	public void configure() throws Throwable
	{
		setAcceptableCoverage(Double.valueOf(getMonitor().getNetwork().getSimulation().getConfiguration().getDouble("acceptable_coverage")).doubleValue());
	}

	public double getAcceptableCoverage()
	{
		return acceptableCoverage;
	}
	public void setAcceptableCoverage(double acceptableCoverage)
	{
		this.acceptableCoverage = acceptableCoverage;
	}
}
