package org.lucci.madhoc.broadcast.impl.standard;

import java.util.Iterator;

import org.lucci.madhoc.broadcast.LocalInfo;
import org.lucci.madhoc.messaging.Message;
import org.lucci.madhoc.messaging.TransferableObject;

/*
 * Created on Aug 21, 2004
 */

/**
 * @author luc.hogie
 */
public class AHBP_EX extends MultiPointRelaying
{
	public void doIt(double time)
	{
		// if there are some new connections, all ads have to be rebroadcasted
		if (!getHostedObjectsMap().isEmpty())
		{
			if (!getComputer().getNetworkingUnit().getNewConnections().isEmpty())
			{
				Iterator i = getHostedObjectsMap().keySet().iterator();

				while (i.hasNext())
				{
					TransferableObject object = (TransferableObject) i.next();
					LocalInfo localInfo = getLocalInfo(object);
					localInfo.decision = 1;
					localInfo.sendStrategy = LocalInfo.PROACTIVE;
					localInfo.retransmissionDate = getSimulatedTime();
				}
			}
		}

		super.doIt(time);
	}

	public String getName()
	{
		return "AHBP-EX";
	}

	public boolean isMultipleRebroadcastAllowed()
	{
		return true;
	}
	
	protected void messageJustBeingSent(Message msg)
	{
		super.messageJustBeingSent(msg);
		getLocalInfo(msg.getContent()).retransmissionDate = Long.MAX_VALUE;
	}
}
