package org.lucci.madhoc.broadcast.impl.standard;

import org.lucci.madhoc.broadcast.LocalInfo;
import org.lucci.madhoc.broadcast.RandomDelayBasedBroadcastingProtocol;
import org.lucci.madhoc.messaging.Message;
import org.lucci.madhoc.messaging.TransferableObject;

/**
 * @author luc.hogie
 * Created on Jun 22, 2004
 */
public class CounterBasedScheme
	extends RandomDelayBasedBroadcastingProtocol
{
	private int threshold = 4;

	protected void messageJustBeingSent(Message ad)
	{
	}

	public int getThreshold()
	{
		return threshold;
	}

	public void setThreshold(int i)
	{
		threshold = i;
	}

	protected void takeDecision(TransferableObject ad)
	{
		LocalInfo info = getLocalInfo(ad);
		info.decision = info.redundantReceptionCount < getThreshold() ? 1 : 0;
	}

	/* (non-Javadoc)
	 * @see org.lucci.madhoc.network.StationApplication#getName()
	 */
	public String getName()
	{
		return "counter-based";
	}


	/* (non-Javadoc)
	 * @see org.lucci.madhoc.broadcast.BroadcastingProtocol#isMultipleRebroadcastAllowed()
	 */
	public boolean isMultipleRebroadcastAllowed()
	{
		return false;
	}
}
