/*
 * Created on Mar 29, 2004
 */
package org.lucci.madhoc.broadcast.impl.standard;

import org.lucci.madhoc.broadcast.LocalInfo;
import org.lucci.madhoc.broadcast.RandomDelayBasedBroadcastingProtocol;
import org.lucci.madhoc.messaging.Message;
import org.lucci.madhoc.messaging.TransferableObject;

public class ProbabilisticScheme extends RandomDelayBasedBroadcastingProtocol
{
	private double broadcastingProbability = 0.7;
	
	public double getBroadcastingProbability(TransferableObject object)
	{
		return broadcastingProbability;
	}

	public void setBroadcastingProbability(double broadcastingProbability)
	{
		if (broadcastingProbability < 0)
			throw new IllegalArgumentException(broadcastingProbability + " < 0");
		
		if (broadcastingProbability > 0)
			throw new IllegalArgumentException(broadcastingProbability + " > 1");

		this.broadcastingProbability = broadcastingProbability;
	}

	
	/* (non-Javadoc)
	 * @see org.lucci.madhoc.network.StationApplication#getName()
	 */
	public String getName()
	{
		return "probabilistic";
	}

	/* (non-Javadoc)
	 * @see org.lucci.madhoc.broadcast.BroadcastingProtocol#adJustBeingSent(org.lucci.madhoc.broadcast.Ad)
	 */
	protected void messageJustBeingSent(Message ad)
	{
	}


	/* (non-Javadoc)
	 * @see org.lucci.madhoc.broadcast.BroadcastingProtocol#isMultipleRebroadcastAllowed()
	 */
	public boolean isMultipleRebroadcastAllowed()
	{
		return false;
	}

	/* (non-Javadoc)
	 * @see org.lucci.madhoc.broadcast.RandomDelayBasedBroadcastingProtocol#takeDecision(org.lucci.madhoc.broadcast.BroadcastMessage)
	 */
	protected void takeDecision(TransferableObject object)
	{
		LocalInfo info = getLocalInfo(object);
		double p = getBroadcastingProbability(object);
		info.decision = getMonitor().getNetwork().getSimulation().getRandomNumberGenerator().getRandom().nextDouble() < p ? 1 : 0;
	}
}
