package org.lucci.madhoc.broadcast.impl.standard;

import java.util.Collection;
import java.util.HashSet;

import org.lucci.madhoc.broadcast.LocalInfo;
import org.lucci.madhoc.broadcast.RandomDelayBasedBroadcastingProtocol;
import org.lucci.madhoc.messaging.Message;
import org.lucci.madhoc.messaging.TransferableObject;
import org.lucci.madhoc.network.Station;

/**
 * @author luc.hogie
 * Created on Jun 22, 2004
 */
public class SBA
	extends RandomDelayBasedBroadcastingProtocol
{
	protected void takeDecision(TransferableObject object)
	{
		LocalInfo info = getLocalInfo(object);
		Collection<Station> newHosts = new HashSet<Station>();
		newHosts.addAll(getComputer().getNetworkingUnit().getNeighborhoodAtHop(2));
		newHosts.addAll(getComputer().getNetworkingUnit().getNeighborhood());

        if (info.message != null)
        {
            newHosts.remove(info.message.getSourceStationApplication().getComputer());
            newHosts.removeAll(info.message.getSourceStationApplication().getComputer().getNetworkingUnit().getNeighborhood());
        }

        info.decision = newHosts.isEmpty() ? 0 : 1;
	}

	
//	protected void adJustReceived(BroadcastMessage ad)
//	{
//		double maxrad = getMaximumDelay();
//		
//		if (getDevice().getNeighborhood().size() > 0)
//		{
//			// recalculate the retransmission date
//			double factor = 1000;
//			maxrad = (factor * getMaximumDegreeIn1HopNeighborhood() / getDevice().getNeighborhood().size());
//		}
//
//		getInfo(ad).retransmissionDate = getSimulatedTimeMillis() + (long) Utilities.getRandomBetween(0, maxrad);
//	}


	/* (non-Javadoc)
	 * @see org.lucci.madhoc.network.StationApplication#getName()
	 */
	public String getName()
	{
		return "SBA";
	}


	/* (non-Javadoc)
	 * @see org.lucci.madhoc.broadcast.BroadcastingProtocol#isMultipleRebroadcastAllowed()
	 */
	public boolean isMultipleRebroadcastAllowed()
	{
		return false;
	}


	/* (non-Javadoc)
	 * @see org.lucci.madhoc.broadcast.BroadcastingProtocol#adJustBeingSent(org.lucci.madhoc.broadcast.BroadcastMessage)
	 */
	protected void messageJustBeingSent(Message msg)
	{
	}


}

