package org.lucci.madhoc.broadcast.measure;

import org.lucci.madhoc.broadcast.BroadcastingMonitor;
import org.lucci.madhoc.simulation.measure.NaturalNumberSensor;
import org.lucci.madhoc.simulation.measure.Unit;
import org.lucci.madhoc.simulation.projection.Projection;


/*
 * Created on Jul 2, 2004
 */

/**
 * @author luc.hogie
 */
public class AverageEmissionEfficiencyMeasure extends NaturalNumberSensor
{

	/* (non-Javadoc)
	 * @see org.lucci.madhoc.simulation.Measure#getName()
	 */
	public String getName()
	{
		return "avg emission efficiency";
	}

	/* (non-Javadoc)
	 * @see org.lucci.madhoc.simulation.measure.NumericalMeasure#getUnit()
	 */
	public Unit getUnit()
	{
		return Unit.NUMBER_OF_STATIONS;
	}

	/* (non-Javadoc)
	 * @see org.lucci.madhoc.simulation.measure.Measure#takeNewValue(org.lucci.madhoc.simulation.Simulation)
	 */
	public Double takeNewDoubleValue(Projection projection)
	{
		BroadcastingMonitor app = (BroadcastingMonitor) getMonitor();
		double emissionCount = app.getAverageNumberOfEmissions(projection.getNetwork().getStations());

		if (emissionCount > 0)
		{
			return app.getEmissionEfficiency(projection.getNetwork().getStations());
		}
		else
		{
			return null;
		}
	}
}
