package org.lucci.madhoc.broadcast.measure;

import java.util.Collection;

import org.lucci.madhoc.broadcast.BroadcastingProtocol;
import org.lucci.madhoc.simulation.measure.DistributionSensor;
import org.lucci.madhoc.simulation.measure.Unit;
import org.lucci.madhoc.simulation.projection.Projection;

/*
 * Created on Jul 20, 2004
 */

/**
 * @author luc.hogie
 */
public class EmissionDistributionMeasure extends DistributionSensor
{

	/* (non-Javadoc)
	 * @see org.lucci.madhoc.simulation.Measure#getName()
	 */
	public String getName()
	{
		return "emission distribution";
	}

	/* (non-Javadoc)
	 * @see org.lucci.madhoc.simulation.DistributionMeasure#getTargetedValue(org.lucci.madhoc.network.StationApplication)
	 */
	public double getTargetedValue(Object object)
	{
		return ((BroadcastingProtocol) object).getAverageNumberOfEmissions();
	}
	

	/* (non-Javadoc)
	 * @see org.lucci.madhoc.simulation.measure.DistributionMeasure#getYUnit()
	 */
	public Unit getYUnit()
	{
		return Unit.NUMBER_OF_MESSAGE;
	}

	/* (non-Javadoc)
	 * @see org.lucci.madhoc.simulation.measure.DistributionMeasure#getTargetSet()
	 */
	public Collection getTargetSet(Projection projection)
	{
		return getMonitor().findApplications(projection.getNetwork().getStations());
	}


	/* (non-Javadoc)
	 * @see org.lucci.madhoc.simulation.measure.DistributionMeasure#getTargetSetName()
	 */
	public String getTargetSetName()
	{
		return "broadcasting stations";
	}

}
