package org.lucci.madhoc.broadcast.measure;

import java.util.Iterator;

import org.lucci.madhoc.broadcast.BroadcastingProtocol;
import org.lucci.madhoc.broadcast.BroadcastingMonitor;
import org.lucci.madhoc.simulation.measure.NaturalIntegerSensor;
import org.lucci.madhoc.simulation.measure.Unit;
import org.lucci.madhoc.simulation.projection.Projection;

/*
 * Created on Jul 2, 2004
 */

/**
 * @author luc.hogie
 */
public class NumberOfMessagesSentByReactivity extends NaturalIntegerSensor
{
	
	/* (non-Javadoc)
	 * @see org.lucci.madhoc.simulation.Measure#getName()
	 */
	public String getName()
	{
		return "number of msgs sent by reactivity";
	}

	/* (non-Javadoc)
	 * @see org.lucci.madhoc.simulation.measure.NumericalMeasure#getUnit()
	 */
	public Unit getUnit()
	{
		return Unit.NUMBER_OF_MESSAGE;
	}

	/* (non-Javadoc)
	 * @see org.lucci.madhoc.simulation.measure.Measure#takeNewValue(org.lucci.madhoc.simulation.Simulation)
	 */
	public Integer takeNewIntegerValue(Projection projection)
	{
		int sum = 0;
		BroadcastingMonitor app = (BroadcastingMonitor) getMonitor();
		Iterator i = app.findApplications(projection.getNetwork().getStations()).iterator();
		
		while (i.hasNext())
		{
			BroadcastingProtocol p = (BroadcastingProtocol) i.next();
			sum += p.getNumberOfReactiveEmissions();
		}
		
		return sum;
	}

}
