package org.lucci.madhoc.broadcast.measure;

import org.lucci.madhoc.broadcast.BroadcastingMonitor;
import org.lucci.madhoc.simulation.measure.NaturalNumberSensor;
import org.lucci.madhoc.simulation.measure.Unit;
import org.lucci.madhoc.simulation.projection.Projection;

/*
 * Created on Jul 2, 2004
 */

/**
 * @author luc.hogie
 */
public class RatioOfRebroadcastingStationsMeasure extends NaturalNumberSensor
{

	/* (non-Javadoc)
	 * @see org.lucci.madhoc.simulation.Measure#getName()
	 */
	public String getName()
	{
		return "ratio of rebroadcasting stations";
	}

	/* (non-Javadoc)
	 * @see org.lucci.madhoc.simulation.measure.NumericalMeasure#getUnit()
	 */
	public Unit getUnit()
	{
		return null;
	}

	/* (non-Javadoc)
	 * @see org.lucci.madhoc.simulation.measure.Measure#takeNewValue(org.lucci.madhoc.simulation.Simulation)
	 */
	public Double takeNewDoubleValue(Projection projection)
	{
		BroadcastingMonitor app = (BroadcastingMonitor) getMonitor();
		
		if (app.getMode() == BroadcastingMonitor.ONE_TO_ALL && !app.isMultipleRebroadcastingAllowed())
		{
			return new Double(app.getRatioOfRebroadcastingStations(projection.getNetwork().getStations()));			
		}
		else
		{
			return null;
		}
	}
}
