package org.lucci.madhoc.broadcasting.malaga;

import java.util.Arrays;
import java.util.Collection;
import java.util.List;

import org.lucci.madhoc.broadcast.BroadcastingMonitor;
import org.lucci.madhoc.broadcast.BroadcastingMonitorInitializer;
import org.lucci.madhoc.network.Station;
import org.lucci.madhoc.network.net.NetworkingTechnology;
import org.lucci.madhoc.network.util.Geometry;
import org.lucci.madhoc.network.util.Graph;

/*
 * Created on May 31, 2005
 */

/**
 * @author luc.hogie
 */
public class MalagaBroadcastingInitializer extends BroadcastingMonitorInitializer
{
	protected Collection getInitialStations()
	{
		int mode = ((BroadcastingMonitor) getMonitor()).getMode();
		
		if (mode == BroadcastingMonitor.ONE_TO_ALL)
		{
			List stationList = Geometry.getStationsOrderByTheirDistanceToTheBarycenter(getMonitor().getNetwork());
			double averageDegree = Graph.getAverageDegree(getMonitor().getNetwork());
			
			// choose a well-connected station
			for (int i = 0; i < stationList.size(); ++i)
			{
				Station randomStation = randomStation = (Station) stationList.get(i);
				
				if (randomStation.getNetworkingUnit().getNeighborhood().size() > averageDegree
					&& randomStation.getNetworkingUnit().getNetworkInterface((NetworkingTechnology) getMonitor().getNetwork().getNetworkTypes().get("wifi")) != null)
				{
					return Arrays.asList(new Object[] {randomStation});
				}
			}
			
			return Arrays.asList(new Object[] {stationList.get(0)});
		}
		else
		{
			throw new IllegalStateException("broadcasting MUST be ONE-2-ALL");
		}
	}
}
