package org.lucci.madhoc.network.env.mall;

import org.lucci.up.data.Point;

public class CityMobility extends HumanMobility
{

    
    @Override
    public double getInSpotSpeed()
    {
        double edgeLenght = getMobileNode().getNetwork().getNetworkEnvironment().getGrid().getEdgeLenght();
        Point center = new Point(edgeLenght / 2, edgeLenght / 2);
        Point location = getMobileNode().getLocation();
        double distanceToCenter = location.getDistanceTo(center);
        
        if (distanceToCenter < edgeLenght / 4)
        {
            return 4;
        }
        else
        {
            double distanceRatio = distanceToCenter / edgeLenght;
            return 4 * 30 * distanceRatio;
        }
    }

    @Override
    public double getOutSpotSpeed()
    {
        double edgeLenght = getMobileNode().getNetwork().getNetworkEnvironment().getGrid().getEdgeLenght();
        Point center = new Point(edgeLenght / 2, edgeLenght / 2);
        Point location = getMobileNode().getLocation();
        double distanceToCenter = location.getDistanceTo(center);
        
        if (distanceToCenter < edgeLenght / 4)
        {
            return 10;
        }
        else
        {
            double distanceRatio = distanceToCenter / edgeLenght;
            return 10 * 40 * distanceRatio;
        }
    }
}
