package org.lucci.madhoc.network.env.mall.monitor;


import java.util.Iterator;

import org.lucci.madhoc.network.Station;
import org.lucci.madhoc.network.env.mall.HumanEnvironment;
import org.lucci.madhoc.network.env.mall.HumanMobility;
import org.lucci.madhoc.simulation.measure.NaturalIntegerSensor;
import org.lucci.madhoc.simulation.measure.Unit;
import org.lucci.madhoc.simulation.projection.Projection;

/*
 * Created on Jul 7, 2004
 */

/**
 * @author luc.hogie
 */
public class NumberOfComputerWithinSpotsSensor extends NaturalIntegerSensor
{
		
		/* (non-Javadoc)
		 * @see org.lucci.madhoc.simulation.Measure#getName()
		 */
		public String getName()
		{
			return "number comp. within shops";
		}
		

		/* (non-Javadoc)
		 * @see org.lucci.madhoc.simulation.NumericalMeasure#getUnit()
		 */
		public Unit getUnit()
		{
			return Unit.NUMBER_OF_STATIONS;
		}

	/* (non-Javadoc)
	 * @see org.lucci.madhoc.simulation.Measure#takeNewValue(org.lucci.madhoc.simulation.Simulation)
	 */
	public Integer takeNewIntegerValue(Projection projection)
	{
		int sum = 0;
		Iterator i = projection.getNetwork().getStations().iterator();
		
		while (i.hasNext())
		{
			Station c = (Station) i.next(); 
			HumanMobility m = (HumanMobility) c.getMobilityModel();
			
			if (m.getTargetedSpot().include(c.getLocation()))
			{
				++sum;
			}
		}
		
		
		return sum;
	}

	public boolean isApplicable(Projection projection)
	{
		return projection.getNetwork().getNetworkEnvironment() instanceof HumanEnvironment;
	}
}
