package org.lucci.madhoc.network.env.mall.monitor;


import java.util.Iterator;

import org.lucci.madhoc.network.Station;
import org.lucci.madhoc.network.Connection;
import org.lucci.madhoc.network.env.mall.HumanEnvironment;
import org.lucci.madhoc.network.env.mall.HumanMobility;
import org.lucci.madhoc.simulation.measure.NaturalIntegerSensor;
import org.lucci.madhoc.simulation.measure.Unit;
import org.lucci.madhoc.simulation.projection.Projection;

/*
 * Created on Jul 7, 2004
 */

/**
 * @author luc.hogie
 */
public class NumberOfShop2OutsideConnections extends NaturalIntegerSensor
{
		
		/* (non-Javadoc)
		 * @see org.lucci.madhoc.simulation.Measure#getName()
		 */
		public String getName()
		{
			return "shop-2-outside connections";
		}
		

		/* (non-Javadoc)
		 * @see org.lucci.madhoc.simulation.NumericalMeasure#getUnit()
		 */
		public Unit getUnit()
		{
			return Unit.NUMBER_OF_CONNECTION;
		}

	/* (non-Javadoc)
	 * @see org.lucci.madhoc.simulation.Measure#takeNewValue(org.lucci.madhoc.simulation.Simulation)
	 */
	public Integer takeNewIntegerValue(Projection projection)
	{
		int sum = 0;
		Iterator i = projection.getNetwork().getConnections().iterator();
		
		while (i.hasNext())
		{
			Connection c = (Connection) i.next();
			Station node1 = c.getNetworkInterface1().getNetworkingUnit().getStation();
			Station node2 = c.getNetworkInterface2().getNetworkingUnit().getStation();
			HumanMobility mob1 = (HumanMobility) node1.getMobilityModel();
			HumanMobility mob2 = (HumanMobility) node2.getMobilityModel();

			
			if (mob1.getTargetedSpot().include(node1.getLocation()) != mob2.getTargetedSpot().include(node2.getLocation()))
			{
				++sum;
			}
		}
		
		return sum;
	}
	

	public boolean isApplicable(Projection projection)
	{
		return projection.getNetwork().getNetworkEnvironment() instanceof HumanEnvironment;
	}
}
