package org.lucci.madhoc.network.env.open_area;

import org.lucci.madhoc.env.MobilityModel;
import org.lucci.madhoc.network.Station;
import org.lucci.madhoc.network.net.Location;
import org.lucci.math.Utilities;


/*
 * Created on Jul 24, 2004
 */

/**
 * @author luc.hogie
 */
public class RandomMobility extends MobilityModel
{

	/* (non-Javadoc)
	 * @see org.lucci.madhoc.mobility.MobilityModel#moveStation(org.lucci.madhoc.network.MobileStation)
	 */
	public void moveStation(double duration, double simulatedTime)
	{
		Station station = getMobileNode();

		double speed = getMobilityMedium().getSpeed();


		double distance = speed * duration;
		double angle = getMobilityMedium().getAngle();
		double newX = station.getLocation().getX() + distance * Math.cos(angle);
		double newY = station.getLocation().getY() + distance * Math.sin(angle);

		// if the mobile station goes out of the bounds
		if ( newX < 0 || newX > station.getNetwork().getNetworkEnvironment().getGrid().getEdgeLenght() - 1 || newY < 0 || newY > station.getNetwork().getNetworkEnvironment().getGrid().getEdgeLenght() - 1 )
		{
			// it just randomly changes direction, it can take any direction
			getMobilityMedium().setAngle(Utilities.getRandomBetween(0, 2 * Math.PI, getMobileNode().getNetwork().getSimulation().getRandomNumberGenerator().getRandom()));
		}
		else
		{
			station.getLocation().setX(newX);
			station.getLocation().setY(newY);
		}
	}

	/* (non-Javadoc)
	 * @see org.lucci.madhoc.Initializable#init(org.lucci.math.relation.Relation)
	 */
	public void configure()
	{
		// initialize the location of the station
		double x = Utilities.getRandomBetween(0, getMobileNode().getNetwork().getNetworkEnvironment().getGrid().getEdgeLenght(), getMobileNode().getNetwork().getSimulation().getRandomNumberGenerator().getRandom());
		double y = Utilities.getRandomBetween(0, getMobileNode().getNetwork().getNetworkEnvironment().getGrid().getEdgeLenght(), getMobileNode().getNetwork().getSimulation().getRandomNumberGenerator().getRandom());
		getMobileNode().setLocation(new Location(x, y));
	}

}
