package org.lucci.madhoc.network.env.open_area.monitor;

import java.awt.Color;

import org.lucci.madhoc.network.Station;
import org.lucci.madhoc.network.env.open_area.RandomWaypointMobility;
import org.lucci.madhoc.network.net.Location;
import org.lucci.up.data.DataElement;
import org.lucci.up.data.Figure;
import org.lucci.up.data.Point;
import org.lucci.up.data.rendering.figure.ConnectedLineFigureRenderer;
import org.lucci.up.data.rendering.point.CirclePointRenderer;
import org.lucci.up.data.rendering.point.PointRenderer;
import org.lucci.up.system.Space;

/*
 * Created on May 25, 2005
 */

/**
 * @author luc.hogie
 */
public class RandomWaypointNodeRenderer extends PointRenderer
{
		CirclePointRenderer adsOvalRenderer = new CirclePointRenderer(); 
		ConnectedLineFigureRenderer lineRenderer = new ConnectedLineFigureRenderer(); 

		public RandomWaypointNodeRenderer()
		{
			adsOvalRenderer.setRadius(3);
			lineRenderer.setColor(Color.lightGray);
		}

		protected void drawImpl(DataElement dataElement, Space space)
		{
			Location point = (Location) dataElement;
			Station computer = point.getComputer();
			RandomWaypointMobility mobility = (RandomWaypointMobility) computer.getMobilityModel();

			if (mobility.getPausetimeLeft() < 0)
			{
				adsOvalRenderer.setColor(Color.green);
				adsOvalRenderer.setFillColor(Color.green);
			}
			else
			{
				adsOvalRenderer.setColor(Color.red);
				adsOvalRenderer.setFillColor(Color.red);
			}
			
			adsOvalRenderer.draw(point, space);
			
			Point destination = mobility.getDestination();
			
			if (destination != null)
			{
				Figure fig = new Figure();
				fig.addPoint(computer.getLocation());
				fig.addPoint(destination);
				fig.addRenderer(lineRenderer);
				lineRenderer.draw(fig, space);
			}
		}
		public String toString()
		{
			return "Random waypoint";
		}
}
