package madhoc.example;

import java.io.IOException;
import java.util.Collection;
import java.util.Iterator;
import java.util.Random;

import org.lucci.madhoc.messaging.Message;
import org.lucci.madhoc.messaging.MessageInformation;
import org.lucci.madhoc.network.Application;
import org.lucci.madhoc.network.Station;
import org.lucci.math.Utilities;
import org.lucci.util.Collections;

public class ExampleApplication extends Application
{
    private long emissionFrequency = 10000;

    private long numberOfBytesReceived = 0;

    public String getName()
    {
        return "example application";
    }


    public void doIt(double time)
    {
        Station s = getComputer();
        Collection<Station> stationCollection = s.getNetworkingUnit().getNeighborhood();

        if (!stationCollection.isEmpty())
        {
            Station randomNeigbor = (Station) Collections.getRandomObject(stationCollection, null);
            sendMessage(new String("<TOTO>").getBytes(), randomNeigbor);
            System.out.println("[" + getComputer().getIdentifier() + "]>sent message      > <TOTO>");
        }

        for (Message msg : getIncomingMessages())
        {
            try
            {
                if (msg.getType() == Message.DELIVERY_FAILURE)
                {
                    System.out.println("[" + getComputer().getIdentifier() + "]<received __ DELIVERY_FAILURE");
                    continue;
                }

                TransferableByteArray byteArray = (TransferableByteArray) msg.getContent();
                byte[] buf = byteArray.getValue();
                String received = new String(buf);
                System.out.println("[" + getComputer().getIdentifier() + "]<received message  < " + received);
            }
            catch (Exception e)
            {
                e.printStackTrace();
            }
        }
    }

    public void configure() throws Throwable
    {
        this.emissionFrequency = getMonitor().getNetwork().getSimulation().getConfiguration().getInteger("example_configuration_key");
    }

    public long getNumberOfBytesReceived()
    {
        return numberOfBytesReceived;
    }

}
