package madhoc.example;

import org.lucci.madhoc.network.Application;
import org.lucci.madhoc.simulation.measure.NaturalIntegerSensor;
import org.lucci.madhoc.simulation.measure.Unit;
import org.lucci.madhoc.simulation.projection.Projection;

public class ExampleSensor extends NaturalIntegerSensor
{

    @Override
    public Integer takeNewIntegerValue(Projection projection)
    {
        int totalNumberOfByteReceived = 0;
        
        for (Application application : getMonitor().getDeployedApplications())
        {
            ExampleApplication exApp = (ExampleApplication) application;
            totalNumberOfByteReceived += exApp.getNumberOfBytesReceived();
        }
        
        return totalNumberOfByteReceived;
    }

    @Override
    public Unit getUnit()
    {
        return Unit.BYTE;
    }

    @Override
    public String getName()
    {
        // TODO Auto-generated method stub
        return "Total number of byte received";
    }

}
