package madhoc.example;

import org.lucci.madhoc.simulation.Monitor;
import org.lucci.madhoc.simulation.TerminationCondition;
import org.lucci.madhoc.simulation.measure.NaturalIntegerSensor;
import org.lucci.madhoc.simulation.projection.IdentityProjection;
import org.lucci.madhoc.simulation.projection.Projection;

public class ExampleTerminationCondition extends TerminationCondition
{

    @Override
    public boolean applicationHasCompleted(Monitor app)
    {
        // the application is considered to have completed when a total of 1024 have been transfered
        NaturalIntegerSensor sensor = (NaturalIntegerSensor) app.getSensorMap().get(ExampleSensor.class);
        Projection networkProjection = app.getNetwork().getProjectionMap().get(IdentityProjection.class);
        return sensor.takeNewIntegerValue(networkProjection) > 1024;
    }

    public void configure() throws Throwable
    {
        // no special configuration
    }

}
